"
 COPYRIGHT (c) 1995 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Geometric subclass: #Circle
	instanceVariableNames: 'center radius'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graphics-Geometry'
!

!Circle class methodsFor: 'documentation'!

copyright
"
 COPYRIGHT (c) 1995 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
    ^ '$Header: /cvs/stx/stx/libbasic2/Circle.st,v 1.5 1995-11-11 15:21:09 cg Exp $'
!

documentation
"
     This class implements a circles which are defined by a radius and
     a centerpoint.
"
! !

!Circle class methodsFor:'instance creation'!

center:centerPoint radius:radius
    "Return a new Circle."

    | aCircle |

    ^ self new center:centerPoint radius:radius
! !

!Circle methodsFor:'converting'!

asEllipticalArc
    ^  EllipticalArc center:center radius:radius 
! !

!Circle methodsFor:'displaying'!

displayStrokedOn:aGC
    aGC displayArcX:boundingBox left
		  y:boundingBox top
	      width:boundingBox width
	     height:boundingBox height
	       from:0 
		 to:360
!

displayFilledOn:aGC
    aGC fillArcX:boundingBox left
	       y:boundingBox top
	   width:boundingBox width
	  height:boundingBox height
	    from:0 
	      to:360
! !

!Circle methodsFor:'accessing'!

center:centerPoint radius:radiusNumber
    "set the center and radius"

    center := centerPoint.
    radius := radiusNumber
!

center 
    "return the center."

    ^ center
! 

radius 
    "return the radius."

    ^ radius
! 

startAngle
    "return the startAngle.
     For circles, this is arbitrary; for compatibility with arcs."

    ^ 0
! 

sweepAngle
    "return the sweepAngle.
     For circles, this is always 360 degrees; for compatibility with arcs."

    ^ 360
! !


